def tri_insertion(t):
    for i in range(len(t)-1):     
        # t[0...i] est trié   
        j = i + 1
        while j > 0 and t[j] < t[j-1] :
            t[j-1], t[j] = t[j], t[j-1]
            j -= 1
        # t[0...i+1] est trié

nb_appel_tri = 0
nb_appel_inserer = 0

def inserer(t, j):
    global nb_appel_inserer     
    nb_appel_inserer += 1
    # On insère t[j] dans t[0...j-1]
    if j == 0 :        
        return 
    if t[j] < t[j-1]:        
        t[j-1], t[j] = t[j], t[j-1]
        inserer(t, j-1)

def tri_insertion_rec(t, i=0):   
    global nb_appel_tri
    nb_appel_tri += 1 
    if i == len(t)-1 :
        #print("C'est trié!")
        return
    else :
        #print("J'insère", t[i+1], "dans", t[0:i+1])
        inserer(t, i+1)        
        tri_insertion_rec(t, i+1)


# Pour augmenter le nombre d'appels récursifs
#https://docs.python.org/3/library/sys.html#sys.setrecursionlimit

taille_t = []
nb_inserer = []

for j in range(100):
    t = []
    for i in range(j, -1, -1):
        t.append(i)
    print(t)
    tri_insertion_rec(t)
    print("nb_appel_tri :",nb_appel_tri)
    print("nb_appel_inserer :", nb_appel_inserer)
    taille_t.append(len(t))
    nb_inserer.append(nb_appel_inserer)
    nb_appel_tri = 0
    nb_appel_inserer = 0

import matplotlib.pyplot as plt

plt.plot(taille_t, nb_inserer)
plt.plot(taille_t, [x**2 for x in taille_t])
plt.plot(taille_t, [2**x for x in taille_t])
plt.plot(taille_t, taille_t)
plt.ylim([0, 10000])
plt.show()